import { SocketObservable, FilteredDataServerResult, MetadataDetail, RequestServerResult } from '@genesislcap/foundation-comms';
/**
 * Type definition for configuration options used for streams.
 * @remarks
 * Used by {@link @genesislcap/grid-pro#StreamDatasource} constructor to configure options for the stream.
 * @alpha
 */
export type ServerSideDatasourceOptions = {
    createDataserverStreamFunc?: (existingParams?: any) => Promise<SocketObservable<FilteredDataServerResult>>;
    createReqRepRequestFunc?: (existingParams?: any) => Promise<RequestServerResult>;
    reloadResourceDataFunc?: (params: any) => Promise<void>;
    resourceName: string;
    resourceParams?: any;
    resourceIndexes?: Map<string, [string]>;
    resourceColDefs?: MetadataDetail[];
    maxRows?: number;
    maxView?: number;
    rowId?: string;
    pagination?: boolean;
    zeroBasedViewNumber?: boolean;
};
//# sourceMappingURL=base.types.d.ts.map