import { __decorate } from "tslib";
import { LifecycleMixin } from '@genesislcap/foundation-utils';
import { customElement, observable } from '@microsoft/fast-element';
import { FoundationElement } from '@microsoft/fast-foundation';
import { ColumnTemplate as template } from './column.template';
/**
 * The Grid Pro Column element.
 * @remarks Used insde the Grid Pro element, to specify the column definitions (ColDef) for a given column.
 * @public
 */
let GridProColumn = class GridProColumn extends LifecycleMixin(FoundationElement) {
    constructor() {
        super(...arguments);
        this.definition = {};
    }
    slottedAgCellChanged() { }
    deepClone() {
        const copy = super.deepClone();
        copy.definition = {};
        if (this.definition) {
            Object.keys(this.definition).forEach((key) => {
                if (typeof this.definition[key] === 'function') {
                    copy.definition[key] = this.definition[key].bind(copy);
                }
                else {
                    copy.definition[key] = structuredClone(this.definition[key]);
                }
            });
        }
        return copy;
    }
};
__decorate([
    observable
], GridProColumn.prototype, "slottedAgCell", void 0);
__decorate([
    observable
], GridProColumn.prototype, "definition", void 0);
GridProColumn = __decorate([
    customElement({
        name: 'grid-pro-column',
        template,
    })
], GridProColumn);
export { GridProColumn };
