import { css } from '@microsoft/fast-element';
import { agExternalStockStyles } from './external';
/**
 * The Grid Pro styles.
 * @public
 * @remarks this is the default CSS, bundles Alpine/Balham/Material AG themes.
 */
export const foundationGridProStyles = css `
  ${agExternalStockStyles}
  :host {
    --datasource-error-background-color: var(--neutral-layer-4);
    --datasource-error-background-opacity: 0.5;
    --datasource-error-dialog-max-width: 50%;
    --datasource-error-dialog-min-width: auto;

    position: relative;
    width: 100%;
    height: 100%;
  }

  :host([ds-disconnected]) {
    display: block;
  }

  :host([ds-disconnected])::part(grid) {
    cursor: not-allowed;
    opacity: 40%;
    pointer-events: none;
  }

  .ag-side-bar,
  .ag-menu {
    --ag-subheader-background-color: var(--ag-background-color);
    --ag-control-panel-background-color: var(--ag-background-color);
  }

  .ag-cell-inline-editing {
    height: inherit !important;
  }

  .hidden {
    display: none;
  }

  .grid-datasource-error-dialog::part(dialog) {
    position: absolute;
    z-index: 2;
    max-width: var(--datasource-error-dialog-max-width);

    --dialog-min-width: var(--datasource-error-dialog-min-width);
  }

  .grid-datasource-error-dialog::before {
    content: '';
    position: absolute;
    top: 50%;
    transform: translateY(-50%);
    left: 0;
    height: 100%;
    width: 100%;
    border-radius: 2px;
    background-color: var(--datasource-error-background-color);
    opacity: var(--datasource-error-background-opacity);
    z-index: 1;
  }
`;
